"""A web3.py Contract class for the IERC1155Errors contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_abi.codec import ABICodec
from eth_abi.registry import registry as default_registry
from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from hexbytes import HexBytes
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, ABIFunction

from .utilities import get_abi_input_types, try_bytecode_hexbytes

structs = {}


class IERC1155ErrorsContractFunctions(ContractFunctions):
    """ContractFunctions for the IERC1155Errors contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


class IERC1155ErrorsERC1155InsufficientBalanceContractError:
    """ContractError for ERC1155InsufficientBalance."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InsufficientBalanceContractError",
    ) -> None:
        self.selector = "0x03dee4c5"
        self.signature = (
            "ERC1155InsufficientBalance(address,uint256,uint256,uint256)"
        )

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InsufficientBalanceContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InsufficientBalance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InsufficientBalanceContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InsufficientBalance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155InvalidApproverContractError:
    """ContractError for ERC1155InvalidApprover."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InvalidApproverContractError",
    ) -> None:
        self.selector = "0x3e31884e"
        self.signature = "ERC1155InvalidApprover(address)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InvalidApproverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InvalidApproverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155InvalidArrayLengthContractError:
    """ContractError for ERC1155InvalidArrayLength."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InvalidArrayLengthContractError",
    ) -> None:
        self.selector = "0x5b059991"
        self.signature = "ERC1155InvalidArrayLength(uint256,uint256)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InvalidArrayLengthContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidArrayLength"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InvalidArrayLengthContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidArrayLength"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155InvalidOperatorContractError:
    """ContractError for ERC1155InvalidOperator."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InvalidOperatorContractError",
    ) -> None:
        self.selector = "0xced3e100"
        self.signature = "ERC1155InvalidOperator(address)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InvalidOperatorContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidOperator"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InvalidOperatorContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidOperator"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155InvalidReceiverContractError:
    """ContractError for ERC1155InvalidReceiver."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InvalidReceiverContractError",
    ) -> None:
        self.selector = "0x57f447ce"
        self.signature = "ERC1155InvalidReceiver(address)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InvalidReceiverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InvalidReceiverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155InvalidSenderContractError:
    """ContractError for ERC1155InvalidSender."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155InvalidSenderContractError",
    ) -> None:
        self.selector = "0x01a83514"
        self.signature = "ERC1155InvalidSender(address)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155InvalidSenderContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155InvalidSenderContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsERC1155MissingApprovalForAllContractError:
    """ContractError for ERC1155MissingApprovalForAll."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC1155ErrorsERC1155MissingApprovalForAllContractError",
    ) -> None:
        self.selector = "0xe237d922"
        self.signature = "ERC1155MissingApprovalForAll(address,address)"

    def decode_error_data(  # type: ignore
        self: "IERC1155ErrorsERC1155MissingApprovalForAllContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155MissingApprovalForAll"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC1155ErrorsERC1155MissingApprovalForAllContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc1155errors_abi
                if item.get("name") == "ERC1155MissingApprovalForAll"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC1155ErrorsContractErrors:
    """ContractErrors for the IERC1155Errors contract."""

    ERC1155InsufficientBalance: (
        IERC1155ErrorsERC1155InsufficientBalanceContractError
    )

    ERC1155InvalidApprover: IERC1155ErrorsERC1155InvalidApproverContractError

    ERC1155InvalidArrayLength: (
        IERC1155ErrorsERC1155InvalidArrayLengthContractError
    )

    ERC1155InvalidOperator: IERC1155ErrorsERC1155InvalidOperatorContractError

    ERC1155InvalidReceiver: IERC1155ErrorsERC1155InvalidReceiverContractError

    ERC1155InvalidSender: IERC1155ErrorsERC1155InvalidSenderContractError

    ERC1155MissingApprovalForAll: (
        IERC1155ErrorsERC1155MissingApprovalForAllContractError
    )

    def __init__(
        self,
    ) -> None:
        self.ERC1155InsufficientBalance = (
            IERC1155ErrorsERC1155InsufficientBalanceContractError()
        )
        self.ERC1155InvalidApprover = (
            IERC1155ErrorsERC1155InvalidApproverContractError()
        )
        self.ERC1155InvalidArrayLength = (
            IERC1155ErrorsERC1155InvalidArrayLengthContractError()
        )
        self.ERC1155InvalidOperator = (
            IERC1155ErrorsERC1155InvalidOperatorContractError()
        )
        self.ERC1155InvalidReceiver = (
            IERC1155ErrorsERC1155InvalidReceiverContractError()
        )
        self.ERC1155InvalidSender = (
            IERC1155ErrorsERC1155InvalidSenderContractError()
        )
        self.ERC1155MissingApprovalForAll = (
            IERC1155ErrorsERC1155MissingApprovalForAllContractError()
        )

        self._all = [
            self.ERC1155InsufficientBalance,
            self.ERC1155InvalidApprover,
            self.ERC1155InvalidArrayLength,
            self.ERC1155InvalidOperator,
            self.ERC1155InvalidReceiver,
            self.ERC1155InvalidSender,
            self.ERC1155MissingApprovalForAll,
        ]

    def decode_custom_error(self, data: str) -> tuple[Any, ...]:
        """Decodes a custom contract error."""
        selector = data[:10]
        for err in self._all:
            if err.selector == selector:
                return err.decode_error_data(HexBytes(data[10:]))

        raise ValueError(
            f"IERC1155Errors does not have a selector matching {selector}"
        )


ierc1155errors_abi: ABI = cast(
    ABI,
    [
        {
            "type": "error",
            "name": "ERC1155InsufficientBalance",
            "inputs": [
                {
                    "name": "sender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "balance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "needed",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC1155InvalidApprover",
            "inputs": [
                {
                    "name": "approver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC1155InvalidArrayLength",
            "inputs": [
                {
                    "name": "idsLength",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "valuesLength",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC1155InvalidOperator",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC1155InvalidReceiver",
            "inputs": [
                {
                    "name": "receiver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC1155InvalidSender",
            "inputs": [
                {"name": "sender", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC1155MissingApprovalForAll",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "owner", "type": "address", "internalType": "address"},
            ],
        },
    ],
)
# pylint: disable=line-too-long
ierc1155errors_bytecode = HexStr("0x")


class IERC1155ErrorsContract(Contract):
    """A web3.py Contract class for the IERC1155Errors contract."""

    abi: ABI = ierc1155errors_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        ierc1155errors_bytecode, "ierc1155errors"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = IERC1155ErrorsContractFunctions(ierc1155errors_abi, self.w3, address)  # type: ignore

            self.errors = IERC1155ErrorsContractErrors()

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    errors: IERC1155ErrorsContractErrors = IERC1155ErrorsContractErrors()

    functions: IERC1155ErrorsContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IERC1155ErrorsContractFunctions(
            ierc1155errors_abi, w3, None
        )
        contract.errors = IERC1155ErrorsContractErrors()

        return contract
