"""A web3.py Contract class for the IERC20Errors contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_abi.codec import ABICodec
from eth_abi.registry import registry as default_registry
from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from hexbytes import HexBytes
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, ABIFunction

from .utilities import get_abi_input_types, try_bytecode_hexbytes

structs = {}


class IERC20ErrorsContractFunctions(ContractFunctions):
    """ContractFunctions for the IERC20Errors contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


class IERC20ErrorsERC20InsufficientAllowanceContractError:
    """ContractError for ERC20InsufficientAllowance."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InsufficientAllowanceContractError",
    ) -> None:
        self.selector = "0xfb8f41b2"
        self.signature = "ERC20InsufficientAllowance(address,uint256,uint256)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InsufficientAllowanceContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InsufficientAllowance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InsufficientAllowanceContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InsufficientAllowance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsERC20InsufficientBalanceContractError:
    """ContractError for ERC20InsufficientBalance."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InsufficientBalanceContractError",
    ) -> None:
        self.selector = "0xe450d38c"
        self.signature = "ERC20InsufficientBalance(address,uint256,uint256)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InsufficientBalanceContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InsufficientBalance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InsufficientBalanceContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InsufficientBalance"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsERC20InvalidApproverContractError:
    """ContractError for ERC20InvalidApprover."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InvalidApproverContractError",
    ) -> None:
        self.selector = "0xe602df05"
        self.signature = "ERC20InvalidApprover(address)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InvalidApproverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InvalidApproverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsERC20InvalidReceiverContractError:
    """ContractError for ERC20InvalidReceiver."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InvalidReceiverContractError",
    ) -> None:
        self.selector = "0xec442f05"
        self.signature = "ERC20InvalidReceiver(address)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InvalidReceiverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InvalidReceiverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsERC20InvalidSenderContractError:
    """ContractError for ERC20InvalidSender."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InvalidSenderContractError",
    ) -> None:
        self.selector = "0x96c6fd1e"
        self.signature = "ERC20InvalidSender(address)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InvalidSenderContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InvalidSenderContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsERC20InvalidSpenderContractError:
    """ContractError for ERC20InvalidSpender."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC20ErrorsERC20InvalidSpenderContractError",
    ) -> None:
        self.selector = "0x94280d62"
        self.signature = "ERC20InvalidSpender(address)"

    def decode_error_data(  # type: ignore
        self: "IERC20ErrorsERC20InvalidSpenderContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidSpender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC20ErrorsERC20InvalidSpenderContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc20errors_abi
                if item.get("name") == "ERC20InvalidSpender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC20ErrorsContractErrors:
    """ContractErrors for the IERC20Errors contract."""

    ERC20InsufficientAllowance: (
        IERC20ErrorsERC20InsufficientAllowanceContractError
    )

    ERC20InsufficientBalance: IERC20ErrorsERC20InsufficientBalanceContractError

    ERC20InvalidApprover: IERC20ErrorsERC20InvalidApproverContractError

    ERC20InvalidReceiver: IERC20ErrorsERC20InvalidReceiverContractError

    ERC20InvalidSender: IERC20ErrorsERC20InvalidSenderContractError

    ERC20InvalidSpender: IERC20ErrorsERC20InvalidSpenderContractError

    def __init__(
        self,
    ) -> None:
        self.ERC20InsufficientAllowance = (
            IERC20ErrorsERC20InsufficientAllowanceContractError()
        )
        self.ERC20InsufficientBalance = (
            IERC20ErrorsERC20InsufficientBalanceContractError()
        )
        self.ERC20InvalidApprover = (
            IERC20ErrorsERC20InvalidApproverContractError()
        )
        self.ERC20InvalidReceiver = (
            IERC20ErrorsERC20InvalidReceiverContractError()
        )
        self.ERC20InvalidSender = IERC20ErrorsERC20InvalidSenderContractError()
        self.ERC20InvalidSpender = (
            IERC20ErrorsERC20InvalidSpenderContractError()
        )

        self._all = [
            self.ERC20InsufficientAllowance,
            self.ERC20InsufficientBalance,
            self.ERC20InvalidApprover,
            self.ERC20InvalidReceiver,
            self.ERC20InvalidSender,
            self.ERC20InvalidSpender,
        ]

    def decode_custom_error(self, data: str) -> tuple[Any, ...]:
        """Decodes a custom contract error."""
        selector = data[:10]
        for err in self._all:
            if err.selector == selector:
                return err.decode_error_data(HexBytes(data[10:]))

        raise ValueError(
            f"IERC20Errors does not have a selector matching {selector}"
        )


ierc20errors_abi: ABI = cast(
    ABI,
    [
        {
            "type": "error",
            "name": "ERC20InsufficientAllowance",
            "inputs": [
                {
                    "name": "spender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "allowance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "needed",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC20InsufficientBalance",
            "inputs": [
                {
                    "name": "sender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "balance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "needed",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidApprover",
            "inputs": [
                {
                    "name": "approver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidReceiver",
            "inputs": [
                {
                    "name": "receiver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidSender",
            "inputs": [
                {"name": "sender", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC20InvalidSpender",
            "inputs": [
                {
                    "name": "spender",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
    ],
)
# pylint: disable=line-too-long
ierc20errors_bytecode = HexStr("0x")


class IERC20ErrorsContract(Contract):
    """A web3.py Contract class for the IERC20Errors contract."""

    abi: ABI = ierc20errors_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        ierc20errors_bytecode, "ierc20errors"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = IERC20ErrorsContractFunctions(ierc20errors_abi, self.w3, address)  # type: ignore

            self.errors = IERC20ErrorsContractErrors()

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    errors: IERC20ErrorsContractErrors = IERC20ErrorsContractErrors()

    functions: IERC20ErrorsContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IERC20ErrorsContractFunctions(
            ierc20errors_abi, w3, None
        )
        contract.errors = IERC20ErrorsContractErrors()

        return contract
