"""A web3.py Contract class for the IERC721Errors contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_abi.codec import ABICodec
from eth_abi.registry import registry as default_registry
from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from hexbytes import HexBytes
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, ABIFunction

from .utilities import get_abi_input_types, try_bytecode_hexbytes

structs = {}


class IERC721ErrorsContractFunctions(ContractFunctions):
    """ContractFunctions for the IERC721Errors contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


class IERC721ErrorsERC721IncorrectOwnerContractError:
    """ContractError for ERC721IncorrectOwner."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721IncorrectOwnerContractError",
    ) -> None:
        self.selector = "0x64283d7b"
        self.signature = "ERC721IncorrectOwner(address,uint256,address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721IncorrectOwnerContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721IncorrectOwner"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721IncorrectOwnerContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721IncorrectOwner"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InsufficientApprovalContractError:
    """ContractError for ERC721InsufficientApproval."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InsufficientApprovalContractError",
    ) -> None:
        self.selector = "0x177e802f"
        self.signature = "ERC721InsufficientApproval(address,uint256)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InsufficientApprovalContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InsufficientApproval"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InsufficientApprovalContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InsufficientApproval"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InvalidApproverContractError:
    """ContractError for ERC721InvalidApprover."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InvalidApproverContractError",
    ) -> None:
        self.selector = "0xa9fbf51f"
        self.signature = "ERC721InvalidApprover(address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InvalidApproverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InvalidApproverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidApprover"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InvalidOperatorContractError:
    """ContractError for ERC721InvalidOperator."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InvalidOperatorContractError",
    ) -> None:
        self.selector = "0x5b08ba18"
        self.signature = "ERC721InvalidOperator(address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InvalidOperatorContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidOperator"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InvalidOperatorContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidOperator"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InvalidOwnerContractError:
    """ContractError for ERC721InvalidOwner."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InvalidOwnerContractError",
    ) -> None:
        self.selector = "0x89c62b64"
        self.signature = "ERC721InvalidOwner(address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InvalidOwnerContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidOwner"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InvalidOwnerContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidOwner"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InvalidReceiverContractError:
    """ContractError for ERC721InvalidReceiver."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InvalidReceiverContractError",
    ) -> None:
        self.selector = "0x64a0ae92"
        self.signature = "ERC721InvalidReceiver(address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InvalidReceiverContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InvalidReceiverContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidReceiver"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721InvalidSenderContractError:
    """ContractError for ERC721InvalidSender."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721InvalidSenderContractError",
    ) -> None:
        self.selector = "0x73c6ac6e"
        self.signature = "ERC721InvalidSender(address)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721InvalidSenderContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721InvalidSenderContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721InvalidSender"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsERC721NonexistentTokenContractError:
    """ContractError for ERC721NonexistentToken."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "IERC721ErrorsERC721NonexistentTokenContractError",
    ) -> None:
        self.selector = "0x7e273289"
        self.signature = "ERC721NonexistentToken(uint256)"

    def decode_error_data(  # type: ignore
        self: "IERC721ErrorsERC721NonexistentTokenContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721NonexistentToken"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["IERC721ErrorsERC721NonexistentTokenContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in ierc721errors_abi
                if item.get("name") == "ERC721NonexistentToken"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class IERC721ErrorsContractErrors:
    """ContractErrors for the IERC721Errors contract."""

    ERC721IncorrectOwner: IERC721ErrorsERC721IncorrectOwnerContractError

    ERC721InsufficientApproval: (
        IERC721ErrorsERC721InsufficientApprovalContractError
    )

    ERC721InvalidApprover: IERC721ErrorsERC721InvalidApproverContractError

    ERC721InvalidOperator: IERC721ErrorsERC721InvalidOperatorContractError

    ERC721InvalidOwner: IERC721ErrorsERC721InvalidOwnerContractError

    ERC721InvalidReceiver: IERC721ErrorsERC721InvalidReceiverContractError

    ERC721InvalidSender: IERC721ErrorsERC721InvalidSenderContractError

    ERC721NonexistentToken: IERC721ErrorsERC721NonexistentTokenContractError

    def __init__(
        self,
    ) -> None:
        self.ERC721IncorrectOwner = (
            IERC721ErrorsERC721IncorrectOwnerContractError()
        )
        self.ERC721InsufficientApproval = (
            IERC721ErrorsERC721InsufficientApprovalContractError()
        )
        self.ERC721InvalidApprover = (
            IERC721ErrorsERC721InvalidApproverContractError()
        )
        self.ERC721InvalidOperator = (
            IERC721ErrorsERC721InvalidOperatorContractError()
        )
        self.ERC721InvalidOwner = IERC721ErrorsERC721InvalidOwnerContractError()
        self.ERC721InvalidReceiver = (
            IERC721ErrorsERC721InvalidReceiverContractError()
        )
        self.ERC721InvalidSender = (
            IERC721ErrorsERC721InvalidSenderContractError()
        )
        self.ERC721NonexistentToken = (
            IERC721ErrorsERC721NonexistentTokenContractError()
        )

        self._all = [
            self.ERC721IncorrectOwner,
            self.ERC721InsufficientApproval,
            self.ERC721InvalidApprover,
            self.ERC721InvalidOperator,
            self.ERC721InvalidOwner,
            self.ERC721InvalidReceiver,
            self.ERC721InvalidSender,
            self.ERC721NonexistentToken,
        ]

    def decode_custom_error(self, data: str) -> tuple[Any, ...]:
        """Decodes a custom contract error."""
        selector = data[:10]
        for err in self._all:
            if err.selector == selector:
                return err.decode_error_data(HexBytes(data[10:]))

        raise ValueError(
            f"IERC721Errors does not have a selector matching {selector}"
        )


ierc721errors_abi: ABI = cast(
    ABI,
    [
        {
            "type": "error",
            "name": "ERC721IncorrectOwner",
            "inputs": [
                {
                    "name": "sender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "owner", "type": "address", "internalType": "address"},
            ],
        },
        {
            "type": "error",
            "name": "ERC721InsufficientApproval",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidApprover",
            "inputs": [
                {
                    "name": "approver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidOperator",
            "inputs": [
                {
                    "name": "operator",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidOwner",
            "inputs": [
                {"name": "owner", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidReceiver",
            "inputs": [
                {
                    "name": "receiver",
                    "type": "address",
                    "internalType": "address",
                }
            ],
        },
        {
            "type": "error",
            "name": "ERC721InvalidSender",
            "inputs": [
                {"name": "sender", "type": "address", "internalType": "address"}
            ],
        },
        {
            "type": "error",
            "name": "ERC721NonexistentToken",
            "inputs": [
                {
                    "name": "tokenId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
        },
    ],
)
# pylint: disable=line-too-long
ierc721errors_bytecode = HexStr("0x")


class IERC721ErrorsContract(Contract):
    """A web3.py Contract class for the IERC721Errors contract."""

    abi: ABI = ierc721errors_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        ierc721errors_bytecode, "ierc721errors"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = IERC721ErrorsContractFunctions(ierc721errors_abi, self.w3, address)  # type: ignore

            self.errors = IERC721ErrorsContractErrors()

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    errors: IERC721ErrorsContractErrors = IERC721ErrorsContractErrors()

    functions: IERC721ErrorsContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IERC721ErrorsContractFunctions(
            ierc721errors_abi, w3, None
        )
        contract.errors = IERC721ErrorsContractErrors()

        return contract
