"""Dataclasses for all structs in the IHyperdriveEvents contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name
# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments
# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import
# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return
from __future__ import annotations

from dataclasses import dataclass

from web3.types import ABIEvent, ABIEventParams

AddLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="AddLiquidity",
    type="event",
)

Approval = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="owner", type="address"),
        ABIEventParams(indexed=True, name="spender", type="address"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="Approval",
    type="event",
)

ApprovalForAll = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="account", type="address"),
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=False, name="approved", type="bool"),
    ],
    name="ApprovalForAll",
    type="event",
)

CloseLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="CloseLong",
    type="event",
)

CloseShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="basePayment", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="CloseShort",
    type="event",
)

CollectGovernanceFee = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
    ],
    name="CollectGovernanceFee",
    type="event",
)

CreateCheckpoint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="checkpointTime", type="uint256"),
        ABIEventParams(
            indexed=False, name="checkpointVaultSharePrice", type="uint256"
        ),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="maturedShorts", type="uint256"),
        ABIEventParams(indexed=False, name="maturedLongs", type="uint256"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
    ],
    name="CreateCheckpoint",
    type="event",
)

Initialize = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="apr", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="Initialize",
    type="event",
)

OpenLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="OpenLong",
    type="event",
)

OpenShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="baseProceeds", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="OpenShort",
    type="event",
)

PauseStatusUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="isPaused", type="bool"),
    ],
    name="PauseStatusUpdated",
    type="event",
)

RedeemWithdrawalShares = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(
            indexed=False, name="withdrawalShareAmount", type="uint256"
        ),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="RedeemWithdrawalShares",
    type="event",
)

RemoveLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(
            indexed=False, name="withdrawalShareAmount", type="uint256"
        ),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="RemoveLiquidity",
    type="event",
)

Sweep = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=True, name="target", type="address"),
    ],
    name="Sweep",
    type="event",
)

TransferSingle = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=True, name="from", type="address"),
        ABIEventParams(indexed=True, name="to", type="address"),
        ABIEventParams(indexed=False, name="id", type="uint256"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="TransferSingle",
    type="event",
)


@dataclass
class ErrorInfo:
    """Custom contract error information."""

    name: str
    selector: str
    signature: str
    inputs: list[ErrorParams]


@dataclass
class ErrorParams:
    """Parameter info for custom contract errors."""

    name: str
    solidity_type: str
    python_type: str
