"""A web3.py Contract class for the IRocketDepositPool contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunction,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, BlockIdentifier, CallOverride, TxParams

from .utilities import (
    dataclass_to_tuple,
    rename_returned_types,
    try_bytecode_hexbytes,
)

structs = {}


class IRocketDepositPoolAssignDepositsContractFunction(ContractFunction):
    """ContractFunction for the assignDeposits method."""

    def __call__(self) -> IRocketDepositPoolAssignDepositsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolDepositContractFunction(ContractFunction):
    """ContractFunction for the deposit method."""

    def __call__(self) -> IRocketDepositPoolDepositContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolGetBalanceContractFunction(ContractFunction):
    """ContractFunction for the getBalance method."""

    def __call__(self) -> IRocketDepositPoolGetBalanceContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolGetExcessBalanceContractFunction(ContractFunction):
    """ContractFunction for the getExcessBalance method."""

    def __call__(self) -> IRocketDepositPoolGetExcessBalanceContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolGetMaximumDepositAmountContractFunction(
    ContractFunction
):
    """ContractFunction for the getMaximumDepositAmount method."""

    def __call__(self) -> IRocketDepositPoolGetMaximumDepositAmountContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolGetNodeBalanceContractFunction(ContractFunction):
    """ContractFunction for the getNodeBalance method."""

    def __call__(self) -> IRocketDepositPoolGetNodeBalanceContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolGetUserBalanceContractFunction(ContractFunction):
    """ContractFunction for the getUserBalance method."""

    def __call__(self) -> IRocketDepositPoolGetUserBalanceContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolMaybeAssignDepositsContractFunction(ContractFunction):
    """ContractFunction for the maybeAssignDeposits method."""

    def __call__(self) -> IRocketDepositPoolMaybeAssignDepositsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class IRocketDepositPoolNodeCreditWithdrawalContractFunction(ContractFunction):
    """ContractFunction for the nodeCreditWithdrawal method."""

    def __call__(self, amount: int) -> IRocketDepositPoolNodeCreditWithdrawalContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(amount))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolNodeDepositContractFunction(ContractFunction):
    """ContractFunction for the nodeDeposit method."""

    def __call__(self, totalAmount: int) -> IRocketDepositPoolNodeDepositContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(totalAmount))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolRecycleDissolvedDepositContractFunction(
    ContractFunction
):
    """ContractFunction for the recycleDissolvedDeposit method."""

    def __call__(self) -> IRocketDepositPoolRecycleDissolvedDepositContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolRecycleExcessCollateralContractFunction(
    ContractFunction
):
    """ContractFunction for the recycleExcessCollateral method."""

    def __call__(self) -> IRocketDepositPoolRecycleExcessCollateralContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolRecycleLiquidatedStakeContractFunction(
    ContractFunction
):
    """ContractFunction for the recycleLiquidatedStake method."""

    def __call__(self) -> IRocketDepositPoolRecycleLiquidatedStakeContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolWithdrawExcessBalanceContractFunction(ContractFunction):
    """ContractFunction for the withdrawExcessBalance method."""

    def __call__(self, amount: int) -> IRocketDepositPoolWithdrawExcessBalanceContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(amount))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IRocketDepositPoolContractFunctions(ContractFunctions):
    """ContractFunctions for the IRocketDepositPool contract."""

    assignDeposits: IRocketDepositPoolAssignDepositsContractFunction

    deposit: IRocketDepositPoolDepositContractFunction

    getBalance: IRocketDepositPoolGetBalanceContractFunction

    getExcessBalance: IRocketDepositPoolGetExcessBalanceContractFunction

    getMaximumDepositAmount: (
        IRocketDepositPoolGetMaximumDepositAmountContractFunction
    )

    getNodeBalance: IRocketDepositPoolGetNodeBalanceContractFunction

    getUserBalance: IRocketDepositPoolGetUserBalanceContractFunction

    maybeAssignDeposits: IRocketDepositPoolMaybeAssignDepositsContractFunction

    nodeCreditWithdrawal: IRocketDepositPoolNodeCreditWithdrawalContractFunction

    nodeDeposit: IRocketDepositPoolNodeDepositContractFunction

    recycleDissolvedDeposit: (
        IRocketDepositPoolRecycleDissolvedDepositContractFunction
    )

    recycleExcessCollateral: (
        IRocketDepositPoolRecycleExcessCollateralContractFunction
    )

    recycleLiquidatedStake: (
        IRocketDepositPoolRecycleLiquidatedStakeContractFunction
    )

    withdrawExcessBalance: (
        IRocketDepositPoolWithdrawExcessBalanceContractFunction
    )

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)
        self.assignDeposits = (
            IRocketDepositPoolAssignDepositsContractFunction.factory(
                "assignDeposits",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="assignDeposits",
            )
        )
        self.deposit = IRocketDepositPoolDepositContractFunction.factory(
            "deposit",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="deposit",
        )
        self.getBalance = IRocketDepositPoolGetBalanceContractFunction.factory(
            "getBalance",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getBalance",
        )
        self.getExcessBalance = (
            IRocketDepositPoolGetExcessBalanceContractFunction.factory(
                "getExcessBalance",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="getExcessBalance",
            )
        )
        self.getMaximumDepositAmount = (
            IRocketDepositPoolGetMaximumDepositAmountContractFunction.factory(
                "getMaximumDepositAmount",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="getMaximumDepositAmount",
            )
        )
        self.getNodeBalance = (
            IRocketDepositPoolGetNodeBalanceContractFunction.factory(
                "getNodeBalance",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="getNodeBalance",
            )
        )
        self.getUserBalance = (
            IRocketDepositPoolGetUserBalanceContractFunction.factory(
                "getUserBalance",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="getUserBalance",
            )
        )
        self.maybeAssignDeposits = (
            IRocketDepositPoolMaybeAssignDepositsContractFunction.factory(
                "maybeAssignDeposits",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="maybeAssignDeposits",
            )
        )
        self.nodeCreditWithdrawal = (
            IRocketDepositPoolNodeCreditWithdrawalContractFunction.factory(
                "nodeCreditWithdrawal",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="nodeCreditWithdrawal",
            )
        )
        self.nodeDeposit = (
            IRocketDepositPoolNodeDepositContractFunction.factory(
                "nodeDeposit",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="nodeDeposit",
            )
        )
        self.recycleDissolvedDeposit = (
            IRocketDepositPoolRecycleDissolvedDepositContractFunction.factory(
                "recycleDissolvedDeposit",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="recycleDissolvedDeposit",
            )
        )
        self.recycleExcessCollateral = (
            IRocketDepositPoolRecycleExcessCollateralContractFunction.factory(
                "recycleExcessCollateral",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="recycleExcessCollateral",
            )
        )
        self.recycleLiquidatedStake = (
            IRocketDepositPoolRecycleLiquidatedStakeContractFunction.factory(
                "recycleLiquidatedStake",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="recycleLiquidatedStake",
            )
        )
        self.withdrawExcessBalance = (
            IRocketDepositPoolWithdrawExcessBalanceContractFunction.factory(
                "withdrawExcessBalance",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="withdrawExcessBalance",
            )
        )


irocketdepositpool_abi: ABI = cast(
    ABI,
    [
        {
            "type": "function",
            "name": "assignDeposits",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "deposit",
            "inputs": [],
            "outputs": [],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "getBalance",
            "inputs": [],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getExcessBalance",
            "inputs": [],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getMaximumDepositAmount",
            "inputs": [],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getNodeBalance",
            "inputs": [],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getUserBalance",
            "inputs": [],
            "outputs": [
                {"name": "", "type": "int256", "internalType": "int256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "maybeAssignDeposits",
            "inputs": [],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "nodeCreditWithdrawal",
            "inputs": [
                {
                    "name": "_amount",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "nodeDeposit",
            "inputs": [
                {
                    "name": "_totalAmount",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "recycleDissolvedDeposit",
            "inputs": [],
            "outputs": [],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "recycleExcessCollateral",
            "inputs": [],
            "outputs": [],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "recycleLiquidatedStake",
            "inputs": [],
            "outputs": [],
            "stateMutability": "payable",
        },
        {
            "type": "function",
            "name": "withdrawExcessBalance",
            "inputs": [
                {
                    "name": "_amount",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
    ],
)
# pylint: disable=line-too-long
irocketdepositpool_bytecode = HexStr("0x")


class IRocketDepositPoolContract(Contract):
    """A web3.py Contract class for the IRocketDepositPool contract."""

    abi: ABI = irocketdepositpool_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        irocketdepositpool_bytecode, "irocketdepositpool"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = IRocketDepositPoolContractFunctions(irocketdepositpool_abi, self.w3, address)  # type: ignore

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    functions: IRocketDepositPoolContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IRocketDepositPoolContractFunctions(
            irocketdepositpool_abi, w3, None
        )

        return contract
